<form (ngSubmit)="onSubmit()"
      [formGroup]="form"
>
  <solidify-detail-presentation [centerTemplate]="centerTemplate"
                                [iconName]="iconNameEnum.archiveAcl"
                                [rightTemplate]="rightTemplate"
  ></solidify-detail-presentation>

  <ng-template #centerTemplate>
    <solidify-searchable-single-select *ngIf="getFormControl(formDefinition.aipId) as fd"
                                       [extraSearchQueryParam]="extraQueryParameters"
                                       [formControl]="fd"
                                       [isDisabled]="model | isNotNullNorUndefined"
                                       [labelKey]="'title'"
                                       [placeholder]="labelTranslateEnum.archive | translate"
                                       [readonly]="readonly"
                                       [required]="formValidationHelper.hasRequiredField(fd)"
                                       [resourceNameSpace]="sharedArchiveNameSpace"
                                       [searchKey]="searchKey"
                                       [state]="sharedArchiveState"
                                       [valueKey]="'resId'"
                                       (valueChange)="archiveSelected($event)"
                                       solidifyValidation
    >
    </solidify-searchable-single-select>

    <solidify-searchable-single-select *ngIf="getFormControl(formDefinition.user) as fd"
                                       [formControl]="fd"
                                       [isDisabled]="model | isNotNullNorUndefined"
                                       [labelCallback]="labelUserCallback"
                                       [extraInfoSecondLineLabelCallback]="extraInfoSecondLineLabelCallback"
                                       [labelKey]="'lastName'"
                                       [placeholder]="labelTranslateEnum.user | translate"
                                       [readonly]="readonly"
                                       [required]="formValidationHelper.hasRequiredField(fd)"
                                       [resourceNameSpace]="sharedUserNameSpace"
                                       [sort]="sharedUserSort"
                                       [state]="sharedUserState"
                                       [valueKey]="'resId'"
                                       solidifyValidation
    >
    </solidify-searchable-single-select>
  </ng-template>

  <ng-template #rightTemplate>
    <mat-form-field (click)="closingDateDatepicker.open()"
                    *ngIf="getFormControl(formDefinition.expiration) as fd"
                    [appearance]="appearanceInputMaterial"
                    [floatLabel]="'always'"
                    [class]="securityService.isRootOrAdmin() ? undefined : classInputIgnored"
                    [class.mat-form-field-invalid]="formValidationHelper.displayInvalidWhenRequired(fd, displayEmptyRequiredFieldInError)"
                    solidifyTooltipOnEllipsis
    >
      <mat-label>{{labelTranslateEnum.expiration | translate}}</mat-label>
      <input [formControl]="fd"
             [matDatepicker]="closingDateDatepicker"
             [solidifyValidation]="errors"
             [placeholder]="labelTranslateEnum.xMonthByDefault | translate:{duration: DEFAULT_DURATION_IN_MONTH}"
             matInput
      >
      <mat-datepicker-toggle [for]="closingDateDatepicker"
                             matSuffix
      ></mat-datepicker-toggle>
      <mat-datepicker #closingDateDatepicker
                      [touchUi]="breakpointService.isSmallerThanMd()"
      ></mat-datepicker>
      <mat-error #errors
                 solidifyTooltipOnEllipsis
      ></mat-error>
    </mat-form-field>

    <ng-template [ngIf]="isDuaRequired">
      <solidify-file-upload-input-container *ngIf="getFormControl(formDefinition.fileChange) as fd"
                                            [backendFileAdapter]="dataFileAdapter"
                                            [readonly]="readonly || fd.disabled"
                                            [uploadButtonLabelToTranslate]="labelTranslateEnum.duaFile"
                                            [titleToTranslate]="labelTranslateEnum.duaFile"
                                            [backendFile]="model?.signedDuaFile"
                                            [resourceId]="model?.resId"
                                            [resourceFileNameSpace]="preservationSpaceOrganizationalUnitArchiveAclActionNameSpace"
                                            [blobProvidedMode]="'RETRIEVE_BY_STORE'"
                                            [formControl]="fd"
                                            class="file-upload"
      ></solidify-file-upload-input-container>
    </ng-template>
  </ng-template>

  <dlcm-shared-additional-information-panel-container *ngIf="model | isNotNullNorUndefined"
                                                      [resource]="model"
  >
  </dlcm-shared-additional-information-panel-container>
</form>
